Skip to navigation

Retrieve an invoice

View as Markdown
Retrieves a specific invoice.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

invoiceKeystringRequired

The ID or number of the invoice. For example, 2c92c8955bd63cc1015bd7c151af02ab or INV-0000001.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
accountIdstringOptional
The ID of the customer account associated with the invoice.
adjustmentAmountdoubleOptional
The amount of the invoice adjustments associated with the invoice.
amountdoubleOptional
The total amount of the invoice.
amountWithoutTaxdoubleOptional
The invoice amount excluding tax.
autoPaybooleanOptional
Whether invoices are automatically picked up for processing in the corresponding payment run.
balancedoubleOptional
The remaining balance of the invoice after all payments, adjustments, and refunds are applied.
billRunIdstringOptional
The id of bill run if the invoice is generated by a bill run.
billToContactIdstring or nullOptional

The ID of the bill-to contact associated with the invoice.

billToContactSnapshotIdstring or nullOptional

The ID of the bill-to contact snapshot associated with the invoice.

commentsstringOptional
Comments about the invoice.
createdByIdstringOptional
The user ID of the person who created the invoice. If a bill run generated the invoice, then the value is the user ID of person who created the bill run.
createdDatestringOptional

The date and time when the invoice was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:31:10.

creditBalanceAdjustmentAmountdoubleOptional

The currency amount of the adjustment applied to the customer’s credit balance.

Note: This field is only available if you have the Credit Balance feature enabled and the Invoice Settlement feature disabled.

creditMemoAmountdoubleOptional

The currency amount of all credit memos applied to this invoice.

Note: This field is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

currencystring or nullOptional

The currency of the invoice.

Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.

discountdoubleOptional
the invoice discount amount.
dueDatedateOptional

The date by which the payment for this invoice is due, in yyyy-mm-dd format.

einvoiceErrorCodestringOptional

The error code when status is “Failed”. This code can either be a Zuora-generated error code or one returned by a third-party e-invoice vendor.

einvoiceErrorMessagestringOptional

The error message when status is “Failed”. This message can either be a Zuora-generated error code or one returned by a third-party e-invoice vendor.

einvoiceFileIdstringOptional

The ID of the e-invoice file.

einvoiceStatusenumOptional

The status of the e-invoice file generation for the invoice.

  • If e-invoicing file generation succeeds, this field is either Generated or Success, and both the error code and message are empty, and the eInvoiceField fieldstores the ID of the generated e-inoice file.
  • If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes RetrieveTimeOut. Once the vendor responds successfully, you can use the ‘Resync E-Invoice Status’ action to update the status automatically. You can view these updates in System Health telemetry.
  • If a failure occurs during e-invoice file generation, this field is Failed and error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.
  • If e-invoice file generation conditionally succeeds, this field is ConditionalSuccess and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.
  • If the e-invoice file has been approved by the tax authority, this field is ApprovedByAuthority. The next status will be either Success or Rejected.
  • If the e-invoice file has been rejected by the government, this field is Rejected. You cannot resend this e-invoice; you must create a new invoice instead. Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.
idstringOptional
The unique ID of the invoice.
includesOneTimebooleanOptional

Specifies whether the invoice includes one-time charges.

includesRecurringbooleanOptional
Specifies whether the invoice includes recurring charges.
includesUsagebooleanOptional
Specifies whether the invoice includes usage charges.
invoiceDatedateOptional
The date that appears on the invoice being created.
invoiceGroupNumberstring or nullOptional

The number of the invoice group associated with the invoice.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

invoiceNumberstringOptional
The unique identification number of the invoice.
lastEmailSentDatestring or nullOptional
The date when the invoice was last emailed.
organizationLabelstringOptional

The organization that this object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

paymentAmountdoubleOptional
The amount of payments applied to the invoice.
paymentTermstring or nullOptional
The name of payment term associated with the invoice.
postedBystring or nullOptional
The user ID of the person who moved the invoice to Posted status.
postedDatedate or nullOptional
The date when the invoice was posted.
refundAmountdoubleOptional
Specifies the amount of a refund that was applied against an earlier payment on the invoice.
sequenceSetIdstring or nullOptional
The ID of the sequence set associated with the invoice.
communicationProfileIdstring or nullOptional
The ID of the communication profile associated with the invoice.
shipToContactIdstring or nullOptional

The ID of the ship-to contact associated with the invoice.

shipToContactSnapshotIdstringOptional

The ID of the ship-to contact snapshot associated with the invoice.

soldToContactIdstring or nullOptional

The ID of the sold-to contact associated with the invoice.

soldToContactSnapshotIdstring or nullOptional

The ID of the sold-to contact snapshot associated with the invoice.

sourceenumOptional
The source of the invoice.
Allowed values:
sourceIdstringOptional

The ID of the invoice source. If an invoice is generated from a bill run, the value is the number of the corresponding bill run.Otherwise, the value is null.

sourceTypeenumOptional
The type of the invoice source.
Allowed values:
statusenumOptional

The status of the invoice.

Note:

  • The Split status is applicable only when you use Split Invoice feature.

  • When an invoice is split, its status changes from Draft to Split, and the newly created invoices retain a reference to the original invoice.

Allowed values:
successbooleanOptional

Returns true if the request was processed successfully.

targetDatedateOptional
This date is used to determine which charges are to be billed. All charges that are to be billed on this date or prior will be included in this bill run.
taxAmountdoubleOptional
The amount of taxation.
taxExemptAmountdoubleOptional
The calculated tax amount excluded due to the exemption.
taxMessagestring or nullOptional
The message that the tax engine return if it calculates the taxes of this invoice fails.
taxStatusenumOptional

The status that the tax engine return after it calculates the taxes of this invoice.

Note: This field is only applicable to tax calculation by third-party tax engines. The Voided status indicates that the tax transaction is successfully canceled on the tax vendor’s side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor’s side.

templateIdstring or nullOptional

The ID of the invoice template.

  • If you have the Flexible Billing Attributes feature enabled, the value of this field depends on the configuration of the invoice template.
    • If you specify an invoice template at the subscription level, the value of this field is automatically populated from the corresponding subscription.
    • If you do not specify any invoice template at the subscription level, the value of this field is automatically populated from the corresponding account.
  • If you have the Flexible Billing Attributes feature disabled, the value of this field is null.
transferredToAccountingenum or nullOptional
Whether the invoice was transferred to an external accounting system.
Allowed values:
updatedByIdstringOptional
The ID of the Zuora user who last updated the invoice.
updatedDatestringOptional
The date when the invoice was last updated.
IntegrationId__NSstringOptional<=255 characters

ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

IntegrationStatus__NSstringOptional<=255 characters

Status of the invoice’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

SyncDate__NSstringOptional<=255 characters

Date when the invoice was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Errors

4XX
Client Request Error
500
Internal Server Error